"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
exports.handleNoMergeGet = exports.handleServerMergePut = exports.handleServerMergePost = exports.handleClientMergeGet = exports.handleClientMergePut = void 0;
var Automerge = require("automerge");
var pgp = require("openpgp");
var sync_1 = require("../../src/sync");
function handleNoMergeGet(db, digest, keystore) {
    var sql = "SELECT content FROM store WHERE hash = '" + digest + "'";
    return new Promise(function (whohoo, doh) {
        db.query(sql, function (e, rs) {
            if (e !== null && e !== undefined) {
                doh(e);
                return;
            }
            else if (rs.rowCount == 0) {
                whohoo(false);
                return;
            }
            var cipherText = rs.rows[0]['content'];
            pgp.message.readArmored(cipherText).then(function (m) {
                var opts = {
                    message: m,
                    privateKeys: [keystore.getPrivateKey()]
                };
                pgp.decrypt(opts).then(function (plainText) {
                    var o = sync_1.Syncable.fromJSON(plainText.data);
                    var r = JSON.stringify(o.m['data']);
                    whohoo(r);
                })["catch"](function (e) {
                    console.error('decrypt', e);
                    doh(e);
                });
            })["catch"](function (e) {
                console.error('mesage', e);
                doh(e);
            });
        });
    });
}
exports.handleNoMergeGet = handleNoMergeGet;
// TODO: add input for change description
function handleServerMergePost(data, db, digest, keystore, signer) {
    var _this = this;
    return new Promise(function (whohoo, doh) {
        var o = JSON.parse(data);
        var cipherText = handleClientMergeGet(db, digest, keystore).then(function (v) { return __awaiter(_this, void 0, void 0, function () {
            var e, s;
            return __generator(this, function (_a) {
                e = undefined;
                s = undefined;
                if (v === undefined) {
                    s = new sync_1.Syncable(digest, data);
                    s.onwrap = function (e) {
                        whohoo(e.toJSON());
                    };
                    digest = s.digest();
                    s.wrap({
                        digest: digest
                    });
                }
                else {
                    e = sync_1.Envelope.fromJSON(v);
                    s = e.unwrap();
                    s.replace(o, 'server merge');
                    e.set(s);
                    s.onwrap = function (e) {
                        whohoo(e.toJSON());
                    };
                    digest = s.digest();
                    s.wrap({
                        digest: digest
                    });
                }
                return [2 /*return*/];
            });
        }); });
    });
}
exports.handleServerMergePost = handleServerMergePost;
// TODO: this still needs to merge with the stored version
function handleServerMergePut(data, db, digest, keystore, signer) {
    return new Promise(function (whohoo, doh) {
        var wrappedData = JSON.parse(data);
        if (wrappedData.s === undefined) {
            doh('signature missing');
            return;
        }
        var e = sync_1.Envelope.fromJSON(wrappedData.m);
        var s = undefined;
        try {
            s = e.unwrap();
        }
        catch (e) {
            console.error(e);
            whohoo(undefined);
        }
        // TODO: we probably should expose method for replacing the signature, this is too intrusive
        s.m = Automerge.change(s.m, 'sign', function (doc) {
            doc['signature'] = wrappedData.s;
        });
        s.setSigner(signer);
        s.onauthenticate = function (v) {
            console.log('vvv', v);
            if (!v) {
                whohoo(undefined);
                return;
            }
            var opts = {
                message: pgp.message.fromText(s.toJSON()),
                publicKeys: keystore.getEncryptKeys()
            };
            pgp.encrypt(opts).then(function (cipherText) {
                var sql = "INSERT INTO store (owner_fingerprint, hash, content) VALUES ('" + signer.fingerprint() + "', '" + digest + "', '" + cipherText.data + "') ON CONFLICT (hash) DO UPDATE SET content = EXCLUDED.content;";
                db.query(sql, function (e, rs) {
                    if (e !== null && e !== undefined) {
                        doh(e);
                        return;
                    }
                    whohoo(true);
                });
            });
        };
        s.authenticate(true);
    });
}
exports.handleServerMergePut = handleServerMergePut;
function handleClientMergeGet(db, digest, keystore) {
    var sql = "SELECT content FROM store WHERE hash = '" + digest + "'";
    return new Promise(function (whohoo, doh) {
        db.query(sql, function (e, rs) {
            console.log('rs', e, rs);
            if (e !== null && e !== undefined) {
                doh(e);
                return;
            }
            else if (rs.rowCount == 0) { // TODO fix the postgres/sqlite method name issues, this will now break on postgres
                whohoo(undefined);
                return;
            }
            var cipherText = rs.rows[0]['content'];
            pgp.message.readArmored(cipherText).then(function (m) {
                var opts = {
                    message: m,
                    privateKeys: [keystore.getPrivateKey()]
                };
                pgp.decrypt(opts).then(function (plainText) {
                    var o = sync_1.Syncable.fromJSON(plainText.data);
                    var e = new sync_1.Envelope(o);
                    whohoo(e.toJSON());
                })["catch"](function (e) {
                    console.error('decrypt', e);
                    doh(e);
                });
            })["catch"](function (e) {
                console.error('mesage', e);
                doh(e);
            });
        });
    });
}
exports.handleClientMergeGet = handleClientMergeGet;
// TODO: this still needs to merge with the stored version
function handleClientMergePut(data, db, digest, keystore, signer) {
    return new Promise(function (whohoo, doh) {
        var s = undefined;
        try {
            var e = sync_1.Envelope.fromJSON(data);
            s = e.unwrap();
        }
        catch (e) {
            whohoo(false);
            console.error(e);
            return;
        }
        s.setSigner(signer);
        s.onauthenticate = function (v) {
            if (!v) {
                whohoo(false);
                return;
            }
            handleClientMergeGet(db, digest, keystore).then(function (v) {
                if (v !== undefined) {
                    var env = sync_1.Envelope.fromJSON(v);
                    s.merge(env.unwrap());
                }
                var opts = {
                    message: pgp.message.fromText(s.toJSON()),
                    publicKeys: keystore.getEncryptKeys()
                };
                pgp.encrypt(opts).then(function (cipherText) {
                    var sql = "INSERT INTO store (owner_fingerprint, hash, content) VALUES ('" + signer.fingerprint() + "', '" + digest + "', '" + cipherText.data + "') ON CONFLICT (hash) DO UPDATE SET content = EXCLUDED.content;";
                    db.query(sql, function (e, rs) {
                        if (e !== null && e !== undefined) {
                            doh(e);
                            return;
                        }
                        whohoo(true);
                    });
                })["catch"](function (e) {
                    doh(e);
                });
            });
        };
        s.authenticate(true);
    });
}
exports.handleClientMergePut = handleClientMergePut;
