"use strict";
exports.__esModule = true;
exports.Config = void 0;
var fs = require("fs");
var ini = require("ini");
var path = require("path");
var Config = /** @class */ (function () {
    function Config(filepath, env_prefix) {
        this.filepath = filepath;
        this.store = {};
        this.censor = [];
        this.require = [];
        this.env_prefix = '';
        if (env_prefix !== undefined) {
            this.env_prefix = env_prefix + "_";
        }
    }
    Config.prototype.process = function () {
        var _this = this;
        var d = fs.readdirSync(this.filepath);
        var r = /.*\.ini$/;
        var _loop_1 = function (i) {
            var f = d[i];
            if (!f.match(r)) {
                return { value: void 0 };
            }
            var fp = path.join(this_1.filepath, f);
            var v = fs.readFileSync(fp, 'utf-8');
            var inid = ini.decode(v);
            var inik = Object.keys(inid);
            var _loop_2 = function (j) {
                var k_section = inik[j];
                var k = k_section.toUpperCase();
                Object.keys(inid[k_section]).forEach(function (k_directive) {
                    var kk = k_directive.toUpperCase();
                    var kkk = k + '_' + kk;
                    var r = inid[k_section][k_directive];
                    var k_env = _this.env_prefix + kkk;
                    var env = process.env[k_env];
                    if (env !== undefined) {
                        console.debug('Environment variable ' + k_env + ' overrides ' + kkk);
                        r = env;
                    }
                    _this.store[kkk] = r;
                });
            };
            for (var j = 0; j < inik.length; j++) {
                _loop_2(j);
            }
        };
        var this_1 = this;
        for (var i = 0; i < d.length; i++) {
            var state_1 = _loop_1(i);
            if (typeof state_1 === "object")
                return state_1.value;
        }
    };
    Config.prototype.get = function (s) {
        return this.store[s];
    };
    Config.prototype.toString = function () {
        var _this = this;
        var s = '';
        Object.keys(this.store).forEach(function (k) {
            s += k + '=' + _this.store[k] + '\n';
        });
        return s;
    };
    return Config;
}());
exports.Config = Config;
