"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PostgresAdapter = exports.SqliteAdapter = void 0;
var pg = __importStar(require("pg"));
var sqlite = __importStar(require("sqlite3"));
var re_creatematch = /^(CREATE)/i;
var re_getmatch = /^(SELECT)/i;
var re_setmatch = /^(INSERT|UPDATE)/i;
var SqliteAdapter = /** @class */ (function () {
    function SqliteAdapter(dbConfig, callback) {
        this.db = new sqlite.Database(dbConfig.name); //, callback);
    }
    SqliteAdapter.prototype.query = function (s, callback) {
        var local_callback = function (e, rs) {
            var r = undefined;
            if (rs !== undefined) {
                r = {
                    rowCount: rs.length,
                    rows: rs,
                };
            }
            callback(e, r);
        };
        if (s.match(re_getmatch)) {
            this.db.all(s, local_callback);
        }
        else if (s.match(re_setmatch)) {
            this.db.run(s, local_callback);
        }
        else if (s.match(re_creatematch)) {
            this.db.run(s, callback);
        }
        else {
            throw 'unhandled query';
        }
    };
    SqliteAdapter.prototype.close = function () {
        this.db.close();
    };
    return SqliteAdapter;
}());
exports.SqliteAdapter = SqliteAdapter;
var PostgresAdapter = /** @class */ (function () {
    function PostgresAdapter(dbConfig) {
        var o = dbConfig;
        o['database'] = o.name;
        this.db = new pg.Pool(o);
        return this.db;
    }
    PostgresAdapter.prototype.query = function (s, callback) {
        this.db.query(s, function (e, rs) {
            var r = {
                length: rs.rowCount,
            };
            rs.length = rs.rowCount;
            if (e === undefined) {
                e = null;
            }
            console.debug(e, rs);
            callback(e, rs);
        });
    };
    PostgresAdapter.prototype.close = function () {
        this.db.end();
    };
    return PostgresAdapter;
}());
exports.PostgresAdapter = PostgresAdapter;
