"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
exports.addressToBytes = exports.bytesToHex = exports.mergeKey = exports.toAddressKey = exports.toKey = void 0;
var crypto = require("./crypto");
function stringToBytes(s) {
    var a = new Uint8Array(20);
    var j = 2;
    for (var i = 0; i < a.byteLength; i++) {
        var n = parseInt(s.substring(j, j + 2), 16);
        a[i] = n;
        j += 2;
    }
    return a;
}
function bytesToHex(a) {
    var s = '';
    for (var i = 0; i < a.byteLength; i++) {
        var h = '00' + a[i].toString(16);
        s += h.slice(-2);
    }
    return s;
}
exports.bytesToHex = bytesToHex;
function mergeKey(a, s) {
    return __awaiter(this, void 0, void 0, function () {
        var y, i, i, z;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    y = new Uint8Array(a.byteLength + s.byteLength);
                    for (i = 0; i < a.byteLength; i++) {
                        y[i] = a[i];
                    }
                    for (i = 0; i < s.byteLength; i++) {
                        y[a.byteLength + i] = s[i];
                    }
                    return [4 /*yield*/, crypto.subtle.digest('SHA-256', y)];
                case 1:
                    z = _a.sent();
                    return [2 /*return*/, bytesToHex(new Uint8Array(z))];
            }
        });
    });
}
exports.mergeKey = mergeKey;
function toKey(v, salt) {
    return __awaiter(this, void 0, void 0, function () {
        var a, s;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    a = stringToBytes(v);
                    s = new TextEncoder().encode(salt);
                    return [4 /*yield*/, mergeKey(a, s)];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.toKey = toKey;
function toAddressKey(zeroExHex, salt) {
    return __awaiter(this, void 0, void 0, function () {
        var a, s;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    a = addressToBytes(zeroExHex);
                    s = new TextEncoder().encode(salt);
                    return [4 /*yield*/, mergeKey(a, s)];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.toAddressKey = toAddressKey;
var re_addrHex = /^0[xX][a-fA-F0-9]{40}$/;
function addressToBytes(s) {
    if (!s.match(re_addrHex)) {
        throw 'invalid address hex';
    }
    return stringToBytes(s);
}
exports.addressToBytes = addressToBytes;
